Index: t3lib/class.t3lib_tceforms.php
===================================================================
--- t3lib/class.t3lib_tceforms.php	(revision 9469)
+++ t3lib/class.t3lib_tceforms.php	(revision )
@@ -2464,10 +2468,10 @@
 	 * @param	array		An array with additional configuration options.
 	 * @return	string		The HTML code for the TCEform field
 	 */
-	function getSingleField_typeFlex($table,$field,$row,&$PA)	{
+	function getSingleField_typeFlex($table, $field, $row, &$PA) {
 
 			// Data Structure:
-		$dataStructArray = t3lib_BEfunc::getFlexFormDS($PA['fieldConf']['config'],$row,$table);
+		$dataStructArray = t3lib_BEfunc::getFlexFormDS($PA['fieldConf']['config'], $row, $table);
 
 			// Manipulate Flexform DS via TSConfig and group access lists
 		if (is_array($dataStructArray)) {
@@ -2477,46 +2481,47 @@
 		}
 
 			// Get data structure:
-		if (is_array($dataStructArray))	{
+		if (is_array($dataStructArray)) {
 
 				// Get data:
 			$xmlData = $PA['itemFormElValue'];
 			$xmlHeaderAttributes = t3lib_div::xmlGetHeaderAttribs($xmlData);
 			$storeInCharset = strtolower($xmlHeaderAttributes['encoding']);
-			if ($storeInCharset)	{
+			if ($storeInCharset) {
-				$currentCharset=$GLOBALS['LANG']->charSet;
+				$currentCharset = $GLOBALS['LANG']->charSet;
-				$xmlData = $GLOBALS['LANG']->csConvObj->conv($xmlData,$storeInCharset,$currentCharset,1);
+				$xmlData = $GLOBALS['LANG']->csConvObj->conv($xmlData, $storeInCharset, $currentCharset, 1);
 			}
-			$editData=t3lib_div::xml2array($xmlData);
+			$editData = t3lib_div::xml2array($xmlData);
-			if (!is_array($editData))	{	// Must be XML parsing error...
+			if (!is_array($editData)) { // Must be XML parsing error...
-				$editData=array();
+				$editData = array();
-			} elseif (!isset($editData['meta']) || !is_array($editData['meta']))	{
+			} elseif (!isset($editData['meta']) || !is_array($editData['meta'])) {
 				$editData['meta'] = array();
 			}
 
 				// Find the data structure if sheets are found:
-			$sheet = $editData['meta']['currentSheetId'] ? $editData['meta']['currentSheetId'] : 'sDEF';	// Sheet to display
+			$sheet = $editData['meta']['currentSheetId'] ? $editData['meta']['currentSheetId'] : 'sDEF'; // Sheet to display
 
 				// Create sheet menu:
+				//TODO; Why is this commented out?
-//			if (is_array($dataStructArray['sheets']))	{
-//				#$item.=$this->getSingleField_typeFlex_sheetMenu($dataStructArray['sheets'], $PA['itemFormElName'].'[meta][currentSheetId]', $sheet).'<br />';
-//			}
+			//			if (is_array($dataStructArray['sheets']))	{
+			//				#$item.=$this->getSingleField_typeFlex_sheetMenu($dataStructArray['sheets'], $PA['itemFormElName'].'[meta][currentSheetId]', $sheet).'<br />';
+			//			}
 
 				// Create language menu:
 			$langChildren = $dataStructArray['meta']['langChildren'] ? 1 : 0;
 			$langDisabled = $dataStructArray['meta']['langDisable'] ? 1 : 0;
 
-			$editData['meta']['currentLangId']=array();
+			$editData['meta']['currentLangId'] = array();
 
 				// Look up page overlays:
-			$checkPageLanguageOverlay = $GLOBALS['BE_USER']->getTSConfigVal('options.checkPageLanguageOverlay')?TRUE:FALSE;
+			$checkPageLanguageOverlay = $GLOBALS['BE_USER']->getTSConfigVal('options.checkPageLanguageOverlay') ? TRUE : FALSE;
-			if ($checkPageLanguageOverlay)	{
+			if ($checkPageLanguageOverlay) {
 				$pageOverlays = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
 					'*',
 					'pages_language_overlay',
-					'pid='.intval($row['pid']).
+					'pid=' . intval($row['pid']) .
-						t3lib_BEfunc::deleteClause('pages_language_overlay').
+					t3lib_BEfunc::deleteClause('pages_language_overlay') .
-						t3lib_BEfunc::versioningPlaceholderClause('pages_language_overlay'),
+					t3lib_BEfunc::versioningPlaceholderClause('pages_language_overlay'),
 					'',
 					'',
 					'',
@@ -2525,82 +2530,81 @@
 			}
 			$languages = $this->getAvailableLanguages();
 
-			foreach($languages as $lInfo)	{
+			foreach ($languages as $lInfo) {
-				if ($GLOBALS['BE_USER']->checkLanguageAccess($lInfo['uid']) && (!$checkPageLanguageOverlay || $lInfo['uid']<=0 || is_array($pageOverlays[$lInfo['uid']])))	{
+				if ($GLOBALS['BE_USER']->checkLanguageAccess($lInfo['uid']) && (!$checkPageLanguageOverlay || $lInfo['uid'] <= 0 || is_array($pageOverlays[$lInfo['uid']]))) {
-					$editData['meta']['currentLangId'][] = 	$lInfo['ISOcode'];
+					$editData['meta']['currentLangId'][] = $lInfo['ISOcode'];
 				}
 			}
-			if (!is_array($editData['meta']['currentLangId']) || !count($editData['meta']['currentLangId']))	{
+			if (!is_array($editData['meta']['currentLangId']) || !count($editData['meta']['currentLangId'])) {
-				$editData['meta']['currentLangId']=array('DEF');
+				$editData['meta']['currentLangId'] = array('DEF');
 			}
 
 			$editData['meta']['currentLangId'] = array_unique($editData['meta']['currentLangId']);
 
-
+				//TODO: Why is this commented out?
-//			if (!$langDisabled && count($languages) > 1)	{
-//				$item.=$this->getSingleField_typeFlex_langMenu($languages, $PA['itemFormElName'].'[meta][currentLangId]', $editData['meta']['currentLangId']).'<br />';
-//			}
+			//			if (!$langDisabled && count($languages) > 1)	{
+			//				$item.=$this->getSingleField_typeFlex_langMenu($languages, $PA['itemFormElName'].'[meta][currentLangId]', $editData['meta']['currentLangId']).'<br />';
+			//			}
 
 			$PA['_noEditDEF'] = FALSE;
-			if ($langChildren || $langDisabled)	{
+			if ($langChildren || $langDisabled) {
 				$rotateLang = array('DEF');
 			} else {
-				if (!in_array('DEF',$editData['meta']['currentLangId']))	{
+				if (!in_array('DEF', $editData['meta']['currentLangId'])) {
-					array_unshift($editData['meta']['currentLangId'],'DEF');
+					array_unshift($editData['meta']['currentLangId'], 'DEF');
 					$PA['_noEditDEF'] = TRUE;
 				}
 				$rotateLang = $editData['meta']['currentLangId'];
 			}
 
 				// Tabs sheets
-			if (is_array($dataStructArray['sheets']))	{
+			if (is_array($dataStructArray['sheets'])) {
 				$tabsToTraverse = array_keys($dataStructArray['sheets']);
 			} else {
 				$tabsToTraverse = array($sheet);
 			}
 
-			foreach ($rotateLang as $lKey)	{
+			foreach ($rotateLang as $lKey) {
-				if (!$langChildren && !$langDisabled)	{
+				if (!$langChildren && !$langDisabled) {
-					$item.= '<strong>'.$this->getLanguageIcon($table,$row,'v'.$lKey).$lKey.':</strong>';
+					$item .= '<strong>' . $this->getLanguageIcon($table, $row, 'v' . $lKey) . $lKey . ':</strong>';
 				}
 
 				$tabParts = array();
-				foreach ($tabsToTraverse as $sheet)	{
+				foreach ($tabsToTraverse as $sheet) {
-					list ($dataStruct, $sheet) = t3lib_div::resolveSheetDefInDS($dataStructArray,$sheet);
+					list ($dataStruct, $sheet) = t3lib_div::resolveSheetDefInDS($dataStructArray, $sheet);
 
 						// Render sheet:
-					if (is_array($dataStruct['ROOT']) && is_array($dataStruct['ROOT']['el']))		{
+					if (is_array($dataStruct['ROOT']) && is_array($dataStruct['ROOT']['el'])) {
-						$lang = 'l'.$lKey;	// Default language, other options are "lUK" or whatever country code (independant of system!!!)
+						$lang = 'l' . $lKey; // Default language, other options are "lUK" or whatever country code (independant of system!!!)
-						$PA['_valLang'] = $langChildren && !$langDisabled ? $editData['meta']['currentLangId'] : 'DEF';	// Default language, other options are "lUK" or whatever country code (independant of system!!!)
+						$PA['_valLang'] = $langChildren && !$langDisabled ? $editData['meta']['currentLangId'] : 'DEF'; // Default language, other options are "lUK" or whatever country code (independant of system!!!)
 						$PA['_lang'] = $lang;
 						$PA['_cshFile'] = ((isset($dataStruct['ROOT']['TCEforms']) && isset($dataStruct['ROOT']['TCEforms']['cshFile'])) ? $dataStruct['ROOT']['TCEforms']['cshFile'] : '');
 
 							// Push the sheet level tab to DynNestedStack
 						if (is_array($dataStructArray['sheets'])) {
 							$tabIdentString = $GLOBALS['TBE_TEMPLATE']->getDynTabMenuId('TCEFORMS:flexform:' . $PA['itemFormElName'] . $PA['_lang']);
-							$this->pushToDynNestedStack('tab', $tabIdentString . '-' . (count($tabParts)+1));
+							$this->pushToDynNestedStack('tab', $tabIdentString . '-' . (count($tabParts) + 1));
 						}
 							// Render flexform:
 						$tRows = $this->getSingleField_typeFlex_draw(
-									$dataStruct['ROOT']['el'],
-									$editData['data'][$sheet][$lang],
-									$table,
-									$field,
-									$row,
-									$PA,
+							$dataStruct['ROOT']['el'],
+							$editData['data'][$sheet][$lang],
+							$table,
+							$field,
+							$row,
+							$PA,
-									'[data]['.$sheet.']['.$lang.']'
+							'[data][' . $sheet . '][' . $lang . ']'
-								);
+						);
-						#$sheetContent= '<table border="0" cellpadding="1" cellspacing="1" class="typo3-TCEforms-flexForm">'.implode('',$tRows).'</table>';
-						$sheetContent = '<div class="typo3-TCEforms-flexForm">'.$tRows.'</div>';
+						$sheetContent = '<div class="typo3-TCEforms-flexForm">' . $tRows . '</div>';
 
-			#			$item = '<div style=" position:absolute;">'.$item.'</div>';
-						//visibility:hidden;
 
 							// Pop the sheet level tab from DynNestedStack
 						if (is_array($dataStructArray['sheets'])) {
-							$this->popFromDynNestedStack('tab', $tabIdentString . '-' . (count($tabParts)+1));
+							$this->popFromDynNestedStack('tab', $tabIdentString . '-' . (count($tabParts) + 1));
 						}
-					} else $sheetContent='Data Structure ERROR: No ROOT element found for sheet "'.$sheet.'".';
+					} else {
+						$sheetContent = 'Data Structure ERROR: No ROOT element found for sheet "' . $sheet . '".';
+					}
 
 						// Add to tab:
 					$tabParts[] = array(
@@ -2611,14 +2615,16 @@
 					);
 				}
 
-				if (is_array($dataStructArray['sheets']))	{
+				if (is_array($dataStructArray['sheets'])) {
 					$dividersToTabsBehaviour = (isset($GLOBALS['TCA'][$table]['ctrl']['dividers2tabs']) ? $GLOBALS['TCA'][$table]['ctrl']['dividers2tabs'] : 1);
-					$item.= $this->getDynTabMenu($tabParts, 'TCEFORMS:flexform:'.$PA['itemFormElName'].$PA['_lang'], $dividersToTabsBehaviour);
+					$item .= $this->getDynTabMenu($tabParts, 'TCEFORMS:flexform:' . $PA['itemFormElName'] . $PA['_lang'], $dividersToTabsBehaviour);
 				} else {
-					$item.= $sheetContent;
+					$item .= $sheetContent;
 				}
 			}
-		} else $item='Data Structure ERROR: '.$dataStructArray;
+		} else {
+			$item = 'Data Structure ERROR: ' . $dataStructArray;
+		}
 
 		return $item;
 	}
@@ -2632,13 +2638,13 @@
 	 * @param	[type]		$multi: ...
 	 * @return	string		HTML for menu
 	 */
-	function getSingleField_typeFlex_langMenu($languages,$elName,$selectedLanguage,$multi=1)	{
+	function getSingleField_typeFlex_langMenu($languages, $elName, $selectedLanguage, $multi = 1) {
-		$opt=array();
+		$opt = array();
-		foreach($languages as $lArr)	{
+		foreach ($languages as $lArr) {
-			$opt[]='<option value="'.htmlspecialchars($lArr['ISOcode']).'"'.(in_array($lArr['ISOcode'],$selectedLanguage)?' selected="selected"':'').'>'.htmlspecialchars($lArr['title']).'</option>';
+			$opt[] = '<option value="' . htmlspecialchars($lArr['ISOcode']) . '"' . (in_array($lArr['ISOcode'], $selectedLanguage) ? ' selected="selected"' : '') . '>' . htmlspecialchars($lArr['title']) . '</option>';
 		}
 
-		$output = '<select id="' . uniqid('tceforms-multiselect-') . ' class="tceforms-select tceforms-multiselect tceforms-flexlangmenu" name="'.$elName.'[]"'.($multi ? ' multiple="multiple" size="'.count($languages).'"' : '').'>'.implode('',$opt).'</select>';
+		$output = '<select id="' . uniqid('tceforms-multiselect-') . ' class="tceforms-select tceforms-multiselect tceforms-flexlangmenu" name="' . $elName . '[]"' . ($multi ? ' multiple="multiple" size="' . count($languages) . '"' : '') . '>' . implode('', $opt) . '</select>';
 
 		return $output;
 	}
@@ -2651,24 +2657,24 @@
 	 * @param	string		Current sheet key
 	 * @return	string		HTML for menu
 	 */
-	function getSingleField_typeFlex_sheetMenu($sArr,$elName,$sheetKey)	{
+	function getSingleField_typeFlex_sheetMenu($sArr, $elName, $sheetKey) {
 
-		$tCells =array();
+		$tCells = array();
-		$pct = round(100/count($sArr));
+		$pct = round(100 / count($sArr));
-		foreach($sArr as $sKey => $sheetCfg)	{
+		foreach ($sArr as $sKey => $sheetCfg) {
-			if ($GLOBALS['BE_USER']->jsConfirmation(1))	{
+			if ($GLOBALS['BE_USER']->jsConfirmation(1)) {
-				$onClick = 'if (confirm(TBE_EDITOR.labels.onChangeAlert) && TBE_EDITOR.checkSubmit(-1)){'.$this->elName($elName).".value='".$sKey."'; TBE_EDITOR.submitForm()};";
+				$onClick = 'if (confirm(TBE_EDITOR.labels.onChangeAlert) && TBE_EDITOR.checkSubmit(-1)){' . $this->elName($elName) . ".value='" . $sKey . "'; TBE_EDITOR.submitForm()};";
 			} else {
-				$onClick = 'if(TBE_EDITOR.checkSubmit(-1)){ '.$this->elName($elName).".value='".$sKey."'; TBE_EDITOR.submitForm();}";
+				$onClick = 'if(TBE_EDITOR.checkSubmit(-1)){ ' . $this->elName($elName) . ".value='" . $sKey . "'; TBE_EDITOR.submitForm();}";
 			}
 
 
-			$tCells[]='<td width="'.$pct.'%" style="'.($sKey==$sheetKey ? 'background-color: #9999cc; font-weight: bold;' : 'background-color: #aaaaaa;').' cursor: hand;" onclick="'.htmlspecialchars($onClick).'" align="center">'.
+			$tCells[] = '<td width="' . $pct . '%" style="' . ($sKey == $sheetKey ? 'background-color: #9999cc; font-weight: bold;' : 'background-color: #aaaaaa;') . ' cursor: hand;" onclick="' . htmlspecialchars($onClick) . '" align="center">' .
-					($sheetCfg['ROOT']['TCEforms']['sheetTitle'] ? $this->sL($sheetCfg['ROOT']['TCEforms']['sheetTitle']) : $sKey).
+						($sheetCfg['ROOT']['TCEforms']['sheetTitle'] ? $this->sL($sheetCfg['ROOT']['TCEforms']['sheetTitle']) : $sKey) .
-					'</td>';
+						'</td>';
 		}
 
-		return '<table border="0" cellpadding="0" cellspacing="2" class="typo3-TCEforms-flexForm-sheetMenu"><tr>'.implode('',$tCells).'</tr></table>';
+		return '<table border="0" cellpadding="0" cellspacing="2" class="typo3-TCEforms-flexForm-sheetMenu"><tr>' . implode('', $tCells) . '</tr></table>';
 	}
 
 	/**
@@ -2686,32 +2692,32 @@
 	 * @param	boolean		Defines whether the next flexform level is open or closed. Comes from _TOGGLE pseudo field in FlexForm xml.
 	 * @return	string		HTMl code for form.
 	 */
-	function getSingleField_typeFlex_draw($dataStruct,$editData,$table,$field,$row,&$PA,$formPrefix='',$level=0,$idPrefix='ID',$toggleClosed=FALSE)	{
+	function getSingleField_typeFlex_draw($dataStruct, $editData, $table, $field, $row, &$PA, $formPrefix = '', $level = 0, $idPrefix = 'ID', $toggleClosed = FALSE) {
 
 		$output = '';
 		$mayRestructureFlexforms = $GLOBALS['BE_USER']->checkLanguageAccess(0);
 
 			// Data Structure array must be ... and array of course...
-		if (is_array($dataStruct))	{
+		if (is_array($dataStruct)) {
-			foreach($dataStruct as $key => $value)	{	// Traversing fields in structure:
+			foreach ($dataStruct as $key => $value) { // Traversing fields in structure:
-				if (is_array($value))	{	// The value of each entry must be an array.
+				if (is_array($value)) { // The value of each entry must be an array.
 
 						// ********************
 						// Making the row:
 						// ********************
 						// Title of field:
-					$theTitle = htmlspecialchars(t3lib_div::fixed_lgd_cs($this->sL($value['tx_templavoila']['title']),30));
+					$theTitle = htmlspecialchars(t3lib_div::fixed_lgd_cs($this->sL($value['tx_templavoila']['title']), 30));
 
 						// If it's a "section" or "container":
-					if ($value['type']=='array')	{
+					if ($value['type'] == 'array') {
 
 							// Creating IDs for form fields:
 							// It's important that the IDs "cascade" - otherwise we can't dynamically expand the flex form because this relies on simple string substitution of the first parts of the id values.
-						$thisId = t3lib_div::shortMd5(uniqid('id',true));	// This is a suffix used for forms on this level
+						$thisId = t3lib_div::shortMd5(uniqid('id', TRUE)); // This is a suffix used for forms on this level
-						$idTagPrefix = $idPrefix.'-'.$thisId;	// $idPrefix is the prefix for elements on lower levels in the hierarchy and we combine this with the thisId value to form a new ID on this level.
+						$idTagPrefix = $idPrefix . '-' . $thisId; // $idPrefix is the prefix for elements on lower levels in the hierarchy and we combine this with the thisId value to form a new ID on this level.
 
 							// If it's a "section" containing other elements:
-						if ($value['section'])	{
+						if ($value['section']) {
 
 								// Load script.aculo.us if flexform sections can be moved by drag'n'drop:
 							$GLOBALS['SOBE']->doc->getPageRenderer()->loadScriptaculous();
@@ -2720,24 +2726,24 @@
 
 								// Render elements in data array for section:
 							$tRows = array();
-							$cc=0;
+							$cc = 0;
-							if (is_array($editData[$key]['el']))	{
+							if (is_array($editData[$key]['el'])) {
-								foreach ($editData[$key]['el'] as $k3 => $v3)	{
+								foreach ($editData[$key]['el'] as $k3 => $v3) {
-									$cc=$k3;
+									$cc = $k3;
-									if (is_array($v3))	{
+									if (is_array($v3)) {
 										$theType = key($v3);
 										$theDat = $v3[$theType];
 										$newSectionEl = $value['el'][$theType];
-										if (is_array($newSectionEl))	{
+										if (is_array($newSectionEl)) {
-											$tRows[]= $this->getSingleField_typeFlex_draw(
+											$tRows[] = $this->getSingleField_typeFlex_draw(
 												array($theType => $newSectionEl),
 												array($theType => $theDat),
 												$table,
 												$field,
 												$row,
 												$PA,
-												$formPrefix.'['.$key.'][el]['.$cc.']',
+												$formPrefix . '[' . $key . '][el][' . $cc . ']',
-												$level+1,
+												$level + 1,
 												$idTagPrefix,
 												$v3['_TOGGLE']
 											);
@@ -2754,7 +2760,7 @@
 
 								// Traversing possible types of new content in the section:
 							$newElementsLinks = array();
-							foreach($value['el'] as $nnKey => $nCfg)	{
+							foreach ($value['el'] as $nnKey => $nCfg) {
 								$additionalJS_post_saved = $this->additionalJS_post;
 								$this->additionalJS_post = array();
 								$additionalJS_submit_saved = $this->additionalJS_submit;
@@ -2766,8 +2772,8 @@
 									$field,
 									$row,
 									$PA,
-									$formPrefix.'['.$key.'][el]['.$idTagPrefix.'-form]',
+									$formPrefix . '[' . $key . '][el][' . $idTagPrefix . '-form]',
-									$level+1,
+									$level + 1,
 									$idTagPrefix
 								);
 
@@ -2775,18 +2781,18 @@
 								$var = uniqid('idvar');
 								$replace = 'replace(/' . $idTagPrefix . '-/g,"' . $idTagPrefix . '-"+' . $var . '+"-")';
 								$onClickInsert = 'var ' . $var . ' = "' . 'idx"+(new Date()).getTime();';
-								// Do not replace $isTagPrefix in setActionStatus() because it needs section id!
+									// Do not replace $isTagPrefix in setActionStatus() because it needs section id!
-								$onClickInsert .= 'new Insertion.Bottom($("'.$idTagPrefix.'"), unescape("'.rawurlencode($newElementTemplate).'").' . $replace . '); setActionStatus("'.$idTagPrefix.'");';
+								$onClickInsert .= 'new Insertion.Bottom($("' . $idTagPrefix . '"), unescape("' . rawurlencode($newElementTemplate) . '").' . $replace . '); setActionStatus("' . $idTagPrefix . '");';
 								$onClickInsert .= 'eval(unescape("' . rawurlencode(implode(';', $this->additionalJS_post)) . '").' . $replace . ');';
 								$onClickInsert .= 'TBE_EDITOR.addActionChecks("submit", unescape("' . rawurlencode(implode(';', $this->additionalJS_submit)) . '").' . $replace . ');';
 								$onClickInsert .= 'return false;';
-								// Kasper's comment (kept for history): Maybe there is a better way to do this than store the HTML for the new element in rawurlencoded format - maybe it even breaks with certain charsets? But for now this works...
+									// Kasper's comment (kept for history): Maybe there is a better way to do this than store the HTML for the new element in rawurlencoded format - maybe it even breaks with certain charsets? But for now this works...
 								$this->additionalJS_post = $additionalJS_post_saved;
 								$this->additionalJS_submit = $additionalJS_submit_saved;
 								$new = $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:cm.new', 1);
-								$newElementsLinks[]= '<a href="#" onclick="'.htmlspecialchars($onClickInsert).'">' .
+								$newElementsLinks[] = '<a href="#" onclick="' . htmlspecialchars($onClickInsert) . '">' .
-									t3lib_iconWorks::getSpriteIcon('actions-document-new') .
+													  t3lib_iconWorks::getSpriteIcon('actions-document-new') .
-									htmlspecialchars(t3lib_div::fixed_lgd_cs($this->sL($nCfg['tx_templavoila']['title']),30)) . '</a>';
+													  htmlspecialchars(t3lib_div::fixed_lgd_cs($this->sL($nCfg['tx_templavoila']['title']), 30)) . '</a>';
 							}
 
 								// Reverting internal variables we don't want to change:
@@ -2794,88 +2800,88 @@
 
 								// Adding the sections:
 							$toggleAll = $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.toggleall', 1);
-							$output.= '
+							$output .= '
 							<div class="t3-form-field-toggle-flexsection">
 								<a href="#" onclick="' . htmlspecialchars('flexFormToggleSubs("' . $idTagPrefix . '"); return false;') . '">'
-									. t3lib_iconWorks::getSpriteIcon('actions-move-right', array('title' => $toggleAll)) . $toggleAll . '
+									   . t3lib_iconWorks::getSpriteIcon('actions-move-right', array('title' => $toggleAll)) . $toggleAll . '
 								</a>
 							</div>
 
 							<div id="' . $idTagPrefix . '" class="t3-form-field-container-flexsection">' . implode('', $tRows) . '</div>';
-							$output.= $mayRestructureFlexforms ? '<div class="t3-form-field-add-flexsection"><strong>' . $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.addnew', 1) . ':</strong> '.implode(' | ',$newElementsLinks).'</div>' : '';
+							$output .= $mayRestructureFlexforms ? '<div class="t3-form-field-add-flexsection"><strong>' . $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.addnew', 1) . ':</strong> ' . implode(' | ', $newElementsLinks) . '</div>' : '';
 						} else {
-							// It is a container
+								// It is a container
 
 							$toggleIcon_open = t3lib_iconWorks::getSpriteIcon('actions-move-down');
 							$toggleIcon_close = t3lib_iconWorks::getSpriteIcon('actions-move-right');
 
 								// Create on-click actions.
-							//$onClickCopy = 'new Insertion.After($("'.$idTagPrefix.'"), getOuterHTML("'.$idTagPrefix.'").replace(/'.$idTagPrefix.'-/g,"'.$idTagPrefix.'-copy"+Math.floor(Math.random()*100000+1)+"-")); return false;';	// Copied elements doesn't work (well) in Safari while they do in Firefox and MSIE! UPDATE: It turned out that copying doesn't work for any browser, simply because the data from the copied form never gets submitted to the server for some reason! So I decided to simply disable copying for now. If it's requested by customers we can look to enable it again and fix the issue. There is one un-fixable problem though; Copying an element like this will violate integrity if files are attached inside that element because the file reference doesn't get an absolute path prefixed to it which would be required to have TCEmain generate a new copy of the file.
+								//$onClickCopy = 'new Insertion.After($("'.$idTagPrefix.'"), getOuterHTML("'.$idTagPrefix.'").replace(/'.$idTagPrefix.'-/g,"'.$idTagPrefix.'-copy"+Math.floor(Math.random()*100000+1)+"-")); return false;';	// Copied elements doesn't work (well) in Safari while they do in Firefox and MSIE! UPDATE: It turned out that copying doesn't work for any browser, simply because the data from the copied form never gets submitted to the server for some reason! So I decided to simply disable copying for now. If it's requested by customers we can look to enable it again and fix the issue. There is one un-fixable problem though; Copying an element like this will violate integrity if files are attached inside that element because the file reference doesn't get an absolute path prefixed to it which would be required to have TCEmain generate a new copy of the file.
-							$onClickRemove = 'if (confirm("Are you sure?")){/*###REMOVE###*/;$("'.$idTagPrefix.'").hide();setActionStatus("'.$idPrefix.'");} return false;';
+							$onClickRemove = 'if (confirm("Are you sure?")){/*###REMOVE###*/;$("' . $idTagPrefix . '").hide();setActionStatus("' . $idPrefix . '");} return false;';
-							$onClickToggle = 'flexFormToggle("'.$idTagPrefix.'"); return false;';
+							$onClickToggle = 'flexFormToggle("' . $idTagPrefix . '"); return false;';
 
-							$onMove = 'flexFormSortable("'.$idPrefix.'")';
+							$onMove = 'flexFormSortable("' . $idPrefix . '")';
 								// Notice: Creating "new" elements after others seemed to be too difficult to do and since moving new elements created in the bottom is now so easy with drag'n'drop I didn't see the need.
 
 
 								// Putting together header of a section. Sections can be removed, copied, opened/closed, moved up and down:
 								// I didn't know how to make something right-aligned without a table, so I put it in a table. can be made into <div>'s if someone like to.
 								// Notice: The fact that I make a "Sortable.create" right onmousedown is that if we initialize this when rendering the form in PHP new and copied elements will not be possible to move as a sortable. But this way a new sortable is initialized everytime someone tries to move and it will always work.
-							$ctrlHeader= '
+							$ctrlHeader = '
 								<table class="t3-form-field-header-flexsection" onmousedown="' . ($mayRestructureFlexforms ? htmlspecialchars($onMove) : '') . '">
 								<tr>
 									<td>
-										<a href="#" onclick="'.htmlspecialchars($onClickToggle).'" id="'.$idTagPrefix.'-toggle">
+										<a href="#" onclick="' . htmlspecialchars($onClickToggle) . '" id="' . $idTagPrefix . '-toggle">
-											'.($toggleClosed?$toggleIcon_close:$toggleIcon_open).'
+											' . ($toggleClosed ? $toggleIcon_close : $toggleIcon_open) . '
 										</a>
-										<strong>'.$theTitle.'</strong> <em><span id="'.$idTagPrefix.'-preview"></span></em>
+										<strong>' . $theTitle . '</strong> <em><span id="' . $idTagPrefix . '-preview"></span></em>
 									</td>
-									<td align="right">'.
+									<td align="right">' .
-										($mayRestructureFlexforms ? t3lib_iconWorks::getSpriteIcon('actions-move-move', array('title' => 'Drag to Move')) : '').
+										  ($mayRestructureFlexforms ? t3lib_iconWorks::getSpriteIcon('actions-move-move', array('title' => 'Drag to Move')) : '') .
-										($mayRestructureFlexforms ? '<a href="#" onclick="'.htmlspecialchars($onClickRemove).'">'.t3lib_iconWorks::getSpriteIcon('actions-edit-delete', array('title' => 'Delete')) : '').
+										  ($mayRestructureFlexforms ? '<a href="#" onclick="' . htmlspecialchars($onClickRemove) . '">' . t3lib_iconWorks::getSpriteIcon('actions-edit-delete', array('title' => 'Delete')) : '') .
-									'</td>
+										  '</td>
 									</tr>
 								</table>';
 
-							$s = t3lib_div::revExplode('[]',$formPrefix,2);
+							$s = t3lib_div::revExplode('[]', $formPrefix, 2);
-							$actionFieldName = '_ACTION_FLEX_FORM'.$PA['itemFormElName'].$s[0].'][_ACTION]['.$s[1];
+							$actionFieldName = '_ACTION_FLEX_FORM' . $PA['itemFormElName'] . $s[0] . '][_ACTION][' . $s[1];
 
 								// Push the container to DynNestedStack as it may be toggled
-							$this->pushToDynNestedStack('flex' , $idTagPrefix);
+							$this->pushToDynNestedStack('flex', $idTagPrefix);
 
 								// Putting together the container:
 							$this->additionalJS_delete = array();
-							$output.= '
+							$output .= '
-								<div id="'.$idTagPrefix.'" class="t3-form-field-container-flexsections">
+								<div id="' . $idTagPrefix . '" class="t3-form-field-container-flexsections">
-									<input id="'.$idTagPrefix.'-action" type="hidden" name="'.htmlspecialchars($actionFieldName).'" value=""/>
+									<input id="' . $idTagPrefix . '-action" type="hidden" name="' . htmlspecialchars($actionFieldName) . '" value=""/>
 
-									'.$ctrlHeader.'
+									' . $ctrlHeader . '
 									<div class="t3-form-field-record-flexsection" id="' . $idTagPrefix . '-content"' . ($toggleClosed ? ' style="display:none;"' : '') . '>' .
-										$this->getSingleField_typeFlex_draw(
-											$value['el'],
-											$editData[$key]['el'],
-											$table,
-											$field,
-											$row,
-											$PA,
+									   $this->getSingleField_typeFlex_draw(
+										   $value['el'],
+										   $editData[$key]['el'],
+										   $table,
+										   $field,
+										   $row,
+										   $PA,
-											$formPrefix.'['.$key.'][el]',
+										   $formPrefix . '[' . $key . '][el]',
-											$level+1,
+										   $level + 1,
-											$idTagPrefix
+										   $idTagPrefix
-										).'
+									   ) . '
 									</div>
-									<input id="'.$idTagPrefix.'-toggleClosed" type="hidden" name="'.htmlspecialchars('data['.$table.']['.$row['uid'].']['.$field.']'.$formPrefix.'[_TOGGLE]').'" value="'.($toggleClosed?1:0).'" />
+									<input id="' . $idTagPrefix . '-toggleClosed" type="hidden" name="' . htmlspecialchars('data[' . $table . '][' . $row['uid'] . '][' . $field . ']' . $formPrefix . '[_TOGGLE]') . '" value="' . ($toggleClosed ? 1 : 0) . '" />
 								</div>';
 							$output = str_replace('/*###REMOVE###*/', t3lib_div::slashJS(htmlspecialchars(implode('', $this->additionalJS_delete))), $output);
-									// NOTICE: We are saving the toggle-state directly in the flexForm XML and "unauthorized" according to the data structure. It means that flexform XML will report unclean and a cleaning operation will remove the recorded togglestates. This is not a fatal problem. Ideally we should save the toggle states in meta-data but it is much harder to do that. And this implementation was easy to make and with no really harmful impact.
+								// NOTICE: We are saving the toggle-state directly in the flexForm XML and "unauthorized" according to the data structure. It means that flexform XML will report unclean and a cleaning operation will remove the recorded togglestates. This is not a fatal problem. Ideally we should save the toggle states in meta-data but it is much harder to do that. And this implementation was easy to make and with no really harmful impact.
 
 								// Pop the container from DynNestedStack
-							$this->popFromDynNestedStack('flex' , $idTagPrefix);
+							$this->popFromDynNestedStack('flex', $idTagPrefix);
 						}
 
-						// If it's a "single form element":
+							// If it's a "single form element":
-					} elseif (is_array($value['TCEforms']['config'])) {	// Rendering a single form element:
+					} elseif (is_array($value['TCEforms']['config'])) { // Rendering a single form element:
 
-						if (is_array($PA['_valLang']))	{
+						if (is_array($PA['_valLang'])) {
 							$rotateLang = $PA['_valLang'];
 						} else {
 							$rotateLang = array($PA['_valLang']);
